/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../libs.h"
#include "../util/flags.h"
#include "../util/array.h"
#include "../util/math.h"
#include "bet.h"
#include "card.h"
#include "dealer.h"
#include "fuck.h"
#include "player.h"
#include "pot.h"
#include "turn.h"
#include "winner.h"

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Fucked if I know

/**
 * Initialize the poker game instance.
 * 
 * @param poker Poker game instance.
 */
void pokerInit(poker_t *poker);

/**
 * Set the game's current blinds.
 * 
 * @param poker Poker game instance.
 * @param blindSmall Small blind value.
 * @param blindBig Big blind value.
 */
void pokerSetBlinds(poker_t *poker, int32_t blindSmall, int32_t blindBig);

/**
 * Reset the poker game instance for the new round.
 * 
 * @param poker Poker game instance.
 */
void pokerResetRound(poker_t *poker);

/**
 * Reset the poker betting round.
 * 
 * @param poker Poker game instance to reset for.
 */
void pokerResetBettingRound(poker_t *poker);

/**
 * Take the blinds from the blind players.
 * 
 * @param poker Poker game instance.
 * @param small Small blind amount.
 * @param big Big blind amount.
 */
void pokerTakeBlinds(poker_t *poker, int32_t small, int32_t big);

/**
 * Gets the amount of chips necessary to call the current bet.
 * 
 * @param poker Poker game instance.
 * @return Chips necessary to call the current bet.
 */
int32_t pokerGetCallValue(poker_t *poker);

/**
 * Gets the count of players still currently left in the round.
 * 
 * @param poker Poker game instance.
 * @return The count of players in the round.
 */
uint8_t pokerInRoundGetCount(poker_t *poker);

/**
 * Returns the sum of chips in the pot(s) that the specified player is in. This
 * does not consider the pot, player or hand, just the pure sum of chips.
 * 
 * @param poker Poker game instance.
 * @param playerIndex Player Index to get the sum of chips from.
 * @return The sum of chips from the pots the player is within.
 */
int32_t pokerPlayerGetPotChipsSum(poker_t *poker, uint8_t playerIndex);

/**
 * Returns the full hand for a given player including the best cards on the 
 * bench.
 * 
 * @param poker Poker game instance.
 * @param player Poker player to get the hand for.
 * @param cards Array to store the cards.
 */
void pokerHandGetFull(
  poker_t *poker, pokerplayer_t *player, card_t cards[POKER_WINNING_FULL_SIZE]
);

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Dealer

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Betting

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Pots


// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Clearly fucking player related

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Turn

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! Winning